# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetInternalOccmDemandSignalDeliveriesResult',
    'AwaitableGetInternalOccmDemandSignalDeliveriesResult',
    'get_internal_occm_demand_signal_deliveries',
    'get_internal_occm_demand_signal_deliveries_output',
]

@pulumi.output_type
class GetInternalOccmDemandSignalDeliveriesResult:
    """
    A collection of values returned by getInternalOccmDemandSignalDeliveries.
    """
    def __init__(__self__, compartment_id=None, filters=None, id=None, internal_occm_demand_signal_delivery_collections=None, occ_customer_group_id=None, occm_demand_signal_item_id=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if internal_occm_demand_signal_delivery_collections and not isinstance(internal_occm_demand_signal_delivery_collections, list):
            raise TypeError("Expected argument 'internal_occm_demand_signal_delivery_collections' to be a list")
        pulumi.set(__self__, "internal_occm_demand_signal_delivery_collections", internal_occm_demand_signal_delivery_collections)
        if occ_customer_group_id and not isinstance(occ_customer_group_id, str):
            raise TypeError("Expected argument 'occ_customer_group_id' to be a str")
        pulumi.set(__self__, "occ_customer_group_id", occ_customer_group_id)
        if occm_demand_signal_item_id and not isinstance(occm_demand_signal_item_id, str):
            raise TypeError("Expected argument 'occm_demand_signal_item_id' to be a str")
        pulumi.set(__self__, "occm_demand_signal_item_id", occm_demand_signal_item_id)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The OCID of the tenancy from which the demand signal delivery resource is created.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetInternalOccmDemandSignalDeliveriesFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        The OCID of this demand signal delivery resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="internalOccmDemandSignalDeliveryCollections")
    def internal_occm_demand_signal_delivery_collections(self) -> Sequence['outputs.GetInternalOccmDemandSignalDeliveriesInternalOccmDemandSignalDeliveryCollectionResult']:
        """
        The list of internal_occm_demand_signal_delivery_collection.
        """
        return pulumi.get(self, "internal_occm_demand_signal_delivery_collections")

    @property
    @pulumi.getter(name="occCustomerGroupId")
    def occ_customer_group_id(self) -> builtins.str:
        """
        The OCID of the corresponding customer group to which this demand signal delivery resource belongs to.
        """
        return pulumi.get(self, "occ_customer_group_id")

    @property
    @pulumi.getter(name="occmDemandSignalItemId")
    def occm_demand_signal_item_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "occm_demand_signal_item_id")


class AwaitableGetInternalOccmDemandSignalDeliveriesResult(GetInternalOccmDemandSignalDeliveriesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInternalOccmDemandSignalDeliveriesResult(
            compartment_id=self.compartment_id,
            filters=self.filters,
            id=self.id,
            internal_occm_demand_signal_delivery_collections=self.internal_occm_demand_signal_delivery_collections,
            occ_customer_group_id=self.occ_customer_group_id,
            occm_demand_signal_item_id=self.occm_demand_signal_item_id)


def get_internal_occm_demand_signal_deliveries(compartment_id: Optional[builtins.str] = None,
                                               filters: Optional[Sequence[Union['GetInternalOccmDemandSignalDeliveriesFilterArgs', 'GetInternalOccmDemandSignalDeliveriesFilterArgsDict']]] = None,
                                               id: Optional[builtins.str] = None,
                                               occ_customer_group_id: Optional[builtins.str] = None,
                                               occm_demand_signal_item_id: Optional[builtins.str] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInternalOccmDemandSignalDeliveriesResult:
    """
    This data source provides the list of Internal Occm Demand Signal Deliveries in Oracle Cloud Infrastructure Capacity Management service.

    This GET call is used to list all demand signal delivery resources within the customer group passed as a query parameter.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_internal_occm_demand_signal_deliveries = oci.CapacityManagement.get_internal_occm_demand_signal_deliveries(compartment_id=compartment_id,
        occ_customer_group_id=test_occ_customer_group["id"],
        id=internal_occm_demand_signal_delivery_id,
        occm_demand_signal_item_id=test_occm_demand_signal_item["id"])
    ```


    :param builtins.str compartment_id: The ocid of the compartment or tenancy in which resources are to be listed. This will also be used for authorization purposes.
    :param builtins.str id: A query parameter to filter the list of demand signals based on it's OCID.
    :param builtins.str occ_customer_group_id: The customer group ocid by which we would filter the list.
    :param builtins.str occm_demand_signal_item_id: A query parameter to filter the list of demand signal items based on it's OCID.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    __args__['id'] = id
    __args__['occCustomerGroupId'] = occ_customer_group_id
    __args__['occmDemandSignalItemId'] = occm_demand_signal_item_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:CapacityManagement/getInternalOccmDemandSignalDeliveries:getInternalOccmDemandSignalDeliveries', __args__, opts=opts, typ=GetInternalOccmDemandSignalDeliveriesResult).value

    return AwaitableGetInternalOccmDemandSignalDeliveriesResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        internal_occm_demand_signal_delivery_collections=pulumi.get(__ret__, 'internal_occm_demand_signal_delivery_collections'),
        occ_customer_group_id=pulumi.get(__ret__, 'occ_customer_group_id'),
        occm_demand_signal_item_id=pulumi.get(__ret__, 'occm_demand_signal_item_id'))
def get_internal_occm_demand_signal_deliveries_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                                      filters: Optional[pulumi.Input[Optional[Sequence[Union['GetInternalOccmDemandSignalDeliveriesFilterArgs', 'GetInternalOccmDemandSignalDeliveriesFilterArgsDict']]]]] = None,
                                                      id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                      occ_customer_group_id: Optional[pulumi.Input[builtins.str]] = None,
                                                      occm_demand_signal_item_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetInternalOccmDemandSignalDeliveriesResult]:
    """
    This data source provides the list of Internal Occm Demand Signal Deliveries in Oracle Cloud Infrastructure Capacity Management service.

    This GET call is used to list all demand signal delivery resources within the customer group passed as a query parameter.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_internal_occm_demand_signal_deliveries = oci.CapacityManagement.get_internal_occm_demand_signal_deliveries(compartment_id=compartment_id,
        occ_customer_group_id=test_occ_customer_group["id"],
        id=internal_occm_demand_signal_delivery_id,
        occm_demand_signal_item_id=test_occm_demand_signal_item["id"])
    ```


    :param builtins.str compartment_id: The ocid of the compartment or tenancy in which resources are to be listed. This will also be used for authorization purposes.
    :param builtins.str id: A query parameter to filter the list of demand signals based on it's OCID.
    :param builtins.str occ_customer_group_id: The customer group ocid by which we would filter the list.
    :param builtins.str occm_demand_signal_item_id: A query parameter to filter the list of demand signal items based on it's OCID.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['filters'] = filters
    __args__['id'] = id
    __args__['occCustomerGroupId'] = occ_customer_group_id
    __args__['occmDemandSignalItemId'] = occm_demand_signal_item_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:CapacityManagement/getInternalOccmDemandSignalDeliveries:getInternalOccmDemandSignalDeliveries', __args__, opts=opts, typ=GetInternalOccmDemandSignalDeliveriesResult)
    return __ret__.apply(lambda __response__: GetInternalOccmDemandSignalDeliveriesResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        internal_occm_demand_signal_delivery_collections=pulumi.get(__response__, 'internal_occm_demand_signal_delivery_collections'),
        occ_customer_group_id=pulumi.get(__response__, 'occ_customer_group_id'),
        occm_demand_signal_item_id=pulumi.get(__response__, 'occm_demand_signal_item_id')))
