# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetDbmulticloudOracleDbAzureVaultAssociationsResult',
    'AwaitableGetDbmulticloudOracleDbAzureVaultAssociationsResult',
    'get_dbmulticloud_oracle_db_azure_vault_associations',
    'get_dbmulticloud_oracle_db_azure_vault_associations_output',
]

@pulumi.output_type
class GetDbmulticloudOracleDbAzureVaultAssociationsResult:
    """
    A collection of values returned by getDbmulticloudOracleDbAzureVaultAssociations.
    """
    def __init__(__self__, compartment_id=None, display_name=None, filters=None, id=None, oracle_db_azure_connector_id=None, oracle_db_azure_vault_association_id=None, oracle_db_azure_vault_association_summary_collections=None, oracle_db_azure_vault_id=None, state=None):
        if compartment_id and not isinstance(compartment_id, str):
            raise TypeError("Expected argument 'compartment_id' to be a str")
        pulumi.set(__self__, "compartment_id", compartment_id)
        if display_name and not isinstance(display_name, str):
            raise TypeError("Expected argument 'display_name' to be a str")
        pulumi.set(__self__, "display_name", display_name)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if oracle_db_azure_connector_id and not isinstance(oracle_db_azure_connector_id, str):
            raise TypeError("Expected argument 'oracle_db_azure_connector_id' to be a str")
        pulumi.set(__self__, "oracle_db_azure_connector_id", oracle_db_azure_connector_id)
        if oracle_db_azure_vault_association_id and not isinstance(oracle_db_azure_vault_association_id, str):
            raise TypeError("Expected argument 'oracle_db_azure_vault_association_id' to be a str")
        pulumi.set(__self__, "oracle_db_azure_vault_association_id", oracle_db_azure_vault_association_id)
        if oracle_db_azure_vault_association_summary_collections and not isinstance(oracle_db_azure_vault_association_summary_collections, list):
            raise TypeError("Expected argument 'oracle_db_azure_vault_association_summary_collections' to be a list")
        pulumi.set(__self__, "oracle_db_azure_vault_association_summary_collections", oracle_db_azure_vault_association_summary_collections)
        if oracle_db_azure_vault_id and not isinstance(oracle_db_azure_vault_id, str):
            raise TypeError("Expected argument 'oracle_db_azure_vault_id' to be a str")
        pulumi.set(__self__, "oracle_db_azure_vault_id", oracle_db_azure_vault_id)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="compartmentId")
    def compartment_id(self) -> builtins.str:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment that contains Oracle DB Azure Vault Association Resource.
        """
        return pulumi.get(self, "compartment_id")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[builtins.str]:
        """
        Display name of Oracle DB Azure Vault Association.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetDbmulticloudOracleDbAzureVaultAssociationsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="oracleDbAzureConnectorId")
    def oracle_db_azure_connector_id(self) -> Optional[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Oracle DB Azure Connector.
        """
        return pulumi.get(self, "oracle_db_azure_connector_id")

    @property
    @pulumi.getter(name="oracleDbAzureVaultAssociationId")
    def oracle_db_azure_vault_association_id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "oracle_db_azure_vault_association_id")

    @property
    @pulumi.getter(name="oracleDbAzureVaultAssociationSummaryCollections")
    def oracle_db_azure_vault_association_summary_collections(self) -> Sequence['outputs.GetDbmulticloudOracleDbAzureVaultAssociationsOracleDbAzureVaultAssociationSummaryCollectionResult']:
        """
        The list of oracle_db_azure_vault_association_summary_collection.
        """
        return pulumi.get(self, "oracle_db_azure_vault_association_summary_collections")

    @property
    @pulumi.getter(name="oracleDbAzureVaultId")
    def oracle_db_azure_vault_id(self) -> Optional[builtins.str]:
        """
        The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Oracle DB Azure Vault.
        """
        return pulumi.get(self, "oracle_db_azure_vault_id")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The current lifecycle state of the Oracle DB Azure Vault Association Resource.
        """
        return pulumi.get(self, "state")


class AwaitableGetDbmulticloudOracleDbAzureVaultAssociationsResult(GetDbmulticloudOracleDbAzureVaultAssociationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDbmulticloudOracleDbAzureVaultAssociationsResult(
            compartment_id=self.compartment_id,
            display_name=self.display_name,
            filters=self.filters,
            id=self.id,
            oracle_db_azure_connector_id=self.oracle_db_azure_connector_id,
            oracle_db_azure_vault_association_id=self.oracle_db_azure_vault_association_id,
            oracle_db_azure_vault_association_summary_collections=self.oracle_db_azure_vault_association_summary_collections,
            oracle_db_azure_vault_id=self.oracle_db_azure_vault_id,
            state=self.state)


def get_dbmulticloud_oracle_db_azure_vault_associations(compartment_id: Optional[builtins.str] = None,
                                                        display_name: Optional[builtins.str] = None,
                                                        filters: Optional[Sequence[Union['GetDbmulticloudOracleDbAzureVaultAssociationsFilterArgs', 'GetDbmulticloudOracleDbAzureVaultAssociationsFilterArgsDict']]] = None,
                                                        oracle_db_azure_connector_id: Optional[builtins.str] = None,
                                                        oracle_db_azure_vault_association_id: Optional[builtins.str] = None,
                                                        oracle_db_azure_vault_id: Optional[builtins.str] = None,
                                                        state: Optional[builtins.str] = None,
                                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDbmulticloudOracleDbAzureVaultAssociationsResult:
    """
    This data source provides the list of Oracle Db Azure Vault Associations in Oracle Cloud Infrastructure Dbmulticloud service.

    Lists the all Oracle DB Azure Associations based on filters.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_oracle_db_azure_vault_associations = oci.oci.get_dbmulticloud_oracle_db_azure_vault_associations(compartment_id=compartment_id,
        display_name=oracle_db_azure_vault_association_display_name,
        oracle_db_azure_connector_id=test_oracle_db_azure_connector["id"],
        oracle_db_azure_vault_association_id=test_oracle_db_azure_vault_association["id"],
        oracle_db_azure_vault_id=test_oracle_db_azure_vault["id"],
        state=oracle_db_azure_vault_association_state)
    ```


    :param builtins.str compartment_id: The [ID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to return Azure Vault Association.
    :param builtins.str oracle_db_azure_connector_id: A filter to return Oracle DB Azure Blob Mount Resources.
    :param builtins.str oracle_db_azure_vault_association_id: A filter to return Oracle DB Azure Vault Association Resources.
    :param builtins.str oracle_db_azure_vault_id: A filter to return Oracle DB Azure Vault Resources.
    :param builtins.str state: A filter to return only resources that match the given lifecycle state. The state value is case-insensitive.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['oracleDbAzureConnectorId'] = oracle_db_azure_connector_id
    __args__['oracleDbAzureVaultAssociationId'] = oracle_db_azure_vault_association_id
    __args__['oracleDbAzureVaultId'] = oracle_db_azure_vault_id
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:oci/getDbmulticloudOracleDbAzureVaultAssociations:getDbmulticloudOracleDbAzureVaultAssociations', __args__, opts=opts, typ=GetDbmulticloudOracleDbAzureVaultAssociationsResult).value

    return AwaitableGetDbmulticloudOracleDbAzureVaultAssociationsResult(
        compartment_id=pulumi.get(__ret__, 'compartment_id'),
        display_name=pulumi.get(__ret__, 'display_name'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        oracle_db_azure_connector_id=pulumi.get(__ret__, 'oracle_db_azure_connector_id'),
        oracle_db_azure_vault_association_id=pulumi.get(__ret__, 'oracle_db_azure_vault_association_id'),
        oracle_db_azure_vault_association_summary_collections=pulumi.get(__ret__, 'oracle_db_azure_vault_association_summary_collections'),
        oracle_db_azure_vault_id=pulumi.get(__ret__, 'oracle_db_azure_vault_id'),
        state=pulumi.get(__ret__, 'state'))
def get_dbmulticloud_oracle_db_azure_vault_associations_output(compartment_id: Optional[pulumi.Input[builtins.str]] = None,
                                                               display_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                               filters: Optional[pulumi.Input[Optional[Sequence[Union['GetDbmulticloudOracleDbAzureVaultAssociationsFilterArgs', 'GetDbmulticloudOracleDbAzureVaultAssociationsFilterArgsDict']]]]] = None,
                                                               oracle_db_azure_connector_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                               oracle_db_azure_vault_association_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                               oracle_db_azure_vault_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                               state: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDbmulticloudOracleDbAzureVaultAssociationsResult]:
    """
    This data source provides the list of Oracle Db Azure Vault Associations in Oracle Cloud Infrastructure Dbmulticloud service.

    Lists the all Oracle DB Azure Associations based on filters.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_oracle_db_azure_vault_associations = oci.oci.get_dbmulticloud_oracle_db_azure_vault_associations(compartment_id=compartment_id,
        display_name=oracle_db_azure_vault_association_display_name,
        oracle_db_azure_connector_id=test_oracle_db_azure_connector["id"],
        oracle_db_azure_vault_association_id=test_oracle_db_azure_vault_association["id"],
        oracle_db_azure_vault_id=test_oracle_db_azure_vault["id"],
        state=oracle_db_azure_vault_association_state)
    ```


    :param builtins.str compartment_id: The [ID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
    :param builtins.str display_name: A filter to return Azure Vault Association.
    :param builtins.str oracle_db_azure_connector_id: A filter to return Oracle DB Azure Blob Mount Resources.
    :param builtins.str oracle_db_azure_vault_association_id: A filter to return Oracle DB Azure Vault Association Resources.
    :param builtins.str oracle_db_azure_vault_id: A filter to return Oracle DB Azure Vault Resources.
    :param builtins.str state: A filter to return only resources that match the given lifecycle state. The state value is case-insensitive.
    """
    __args__ = dict()
    __args__['compartmentId'] = compartment_id
    __args__['displayName'] = display_name
    __args__['filters'] = filters
    __args__['oracleDbAzureConnectorId'] = oracle_db_azure_connector_id
    __args__['oracleDbAzureVaultAssociationId'] = oracle_db_azure_vault_association_id
    __args__['oracleDbAzureVaultId'] = oracle_db_azure_vault_id
    __args__['state'] = state
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:oci/getDbmulticloudOracleDbAzureVaultAssociations:getDbmulticloudOracleDbAzureVaultAssociations', __args__, opts=opts, typ=GetDbmulticloudOracleDbAzureVaultAssociationsResult)
    return __ret__.apply(lambda __response__: GetDbmulticloudOracleDbAzureVaultAssociationsResult(
        compartment_id=pulumi.get(__response__, 'compartment_id'),
        display_name=pulumi.get(__response__, 'display_name'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        oracle_db_azure_connector_id=pulumi.get(__response__, 'oracle_db_azure_connector_id'),
        oracle_db_azure_vault_association_id=pulumi.get(__response__, 'oracle_db_azure_vault_association_id'),
        oracle_db_azure_vault_association_summary_collections=pulumi.get(__response__, 'oracle_db_azure_vault_association_summary_collections'),
        oracle_db_azure_vault_id=pulumi.get(__response__, 'oracle_db_azure_vault_id'),
        state=pulumi.get(__response__, 'state')))
