# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetWlmsWlsDomainAgreementRecordsResult',
    'AwaitableGetWlmsWlsDomainAgreementRecordsResult',
    'get_wlms_wls_domain_agreement_records',
    'get_wlms_wls_domain_agreement_records_output',
]

@pulumi.output_type
class GetWlmsWlsDomainAgreementRecordsResult:
    """
    A collection of values returned by getWlmsWlsDomainAgreementRecords.
    """
    def __init__(__self__, agreement_record_collections=None, filters=None, id=None, wls_domain_id=None):
        if agreement_record_collections and not isinstance(agreement_record_collections, list):
            raise TypeError("Expected argument 'agreement_record_collections' to be a list")
        pulumi.set(__self__, "agreement_record_collections", agreement_record_collections)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if wls_domain_id and not isinstance(wls_domain_id, str):
            raise TypeError("Expected argument 'wls_domain_id' to be a str")
        pulumi.set(__self__, "wls_domain_id", wls_domain_id)

    @property
    @pulumi.getter(name="agreementRecordCollections")
    def agreement_record_collections(self) -> Sequence['outputs.GetWlmsWlsDomainAgreementRecordsAgreementRecordCollectionResult']:
        """
        The list of agreement_record_collection.
        """
        return pulumi.get(self, "agreement_record_collections")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetWlmsWlsDomainAgreementRecordsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="wlsDomainId")
    def wls_domain_id(self) -> builtins.str:
        return pulumi.get(self, "wls_domain_id")


class AwaitableGetWlmsWlsDomainAgreementRecordsResult(GetWlmsWlsDomainAgreementRecordsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWlmsWlsDomainAgreementRecordsResult(
            agreement_record_collections=self.agreement_record_collections,
            filters=self.filters,
            id=self.id,
            wls_domain_id=self.wls_domain_id)


def get_wlms_wls_domain_agreement_records(filters: Optional[Sequence[Union['GetWlmsWlsDomainAgreementRecordsFilterArgs', 'GetWlmsWlsDomainAgreementRecordsFilterArgsDict']]] = None,
                                          wls_domain_id: Optional[builtins.str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWlmsWlsDomainAgreementRecordsResult:
    """
    This data source provides the list of Wls Domain Agreement Records in Oracle Cloud Infrastructure Wlms service.

    List the terms of use agreement record for the WebLogic domain.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_wls_domain_agreement_records = oci.oci.get_wlms_wls_domain_agreement_records(wls_domain_id=test_wls_domain["id"])
    ```


    :param builtins.str wls_domain_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the WebLogic domain.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['wlsDomainId'] = wls_domain_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('oci:oci/getWlmsWlsDomainAgreementRecords:getWlmsWlsDomainAgreementRecords', __args__, opts=opts, typ=GetWlmsWlsDomainAgreementRecordsResult).value

    return AwaitableGetWlmsWlsDomainAgreementRecordsResult(
        agreement_record_collections=pulumi.get(__ret__, 'agreement_record_collections'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        wls_domain_id=pulumi.get(__ret__, 'wls_domain_id'))
def get_wlms_wls_domain_agreement_records_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetWlmsWlsDomainAgreementRecordsFilterArgs', 'GetWlmsWlsDomainAgreementRecordsFilterArgsDict']]]]] = None,
                                                 wls_domain_id: Optional[pulumi.Input[builtins.str]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWlmsWlsDomainAgreementRecordsResult]:
    """
    This data source provides the list of Wls Domain Agreement Records in Oracle Cloud Infrastructure Wlms service.

    List the terms of use agreement record for the WebLogic domain.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_oci as oci

    test_wls_domain_agreement_records = oci.oci.get_wlms_wls_domain_agreement_records(wls_domain_id=test_wls_domain["id"])
    ```


    :param builtins.str wls_domain_id: The [OCID](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the WebLogic domain.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['wlsDomainId'] = wls_domain_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('oci:oci/getWlmsWlsDomainAgreementRecords:getWlmsWlsDomainAgreementRecords', __args__, opts=opts, typ=GetWlmsWlsDomainAgreementRecordsResult)
    return __ret__.apply(lambda __response__: GetWlmsWlsDomainAgreementRecordsResult(
        agreement_record_collections=pulumi.get(__response__, 'agreement_record_collections'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        wls_domain_id=pulumi.get(__response__, 'wls_domain_id')))
