# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'OciCacheUserAuthenticationModeArgs',
    'OciCacheUserAuthenticationModeArgsDict',
    'OciCacheUserGetRedisClusterOciCacheClusterArgs',
    'OciCacheUserGetRedisClusterOciCacheClusterArgsDict',
    'RedisClusterGetOciCacheUserOciCacheUserArgs',
    'RedisClusterGetOciCacheUserOciCacheUserArgsDict',
    'RedisClusterNodeCollectionArgs',
    'RedisClusterNodeCollectionArgsDict',
    'RedisClusterNodeCollectionItemArgs',
    'RedisClusterNodeCollectionItemArgsDict',
    'GetOciCacheUsersFilterArgs',
    'GetOciCacheUsersFilterArgsDict',
    'GetRedisClusterNodesFilterArgs',
    'GetRedisClusterNodesFilterArgsDict',
    'GetRedisClustersFilterArgs',
    'GetRedisClustersFilterArgsDict',
]

MYPY = False

if not MYPY:
    class OciCacheUserAuthenticationModeArgsDict(TypedDict):
        authentication_type: pulumi.Input[builtins.str]
        """
        (Updatable) This is Authentication Type of Oracle Cloud Infrastructure cache user
        """
        hashed_passwords: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        (Updatable) SHA-256 hashed passwords for Oracle Cloud Infrastructure Cache user,required if authenticationType is set to PASSWORD.
        """
elif False:
    OciCacheUserAuthenticationModeArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class OciCacheUserAuthenticationModeArgs:
    def __init__(__self__, *,
                 authentication_type: pulumi.Input[builtins.str],
                 hashed_passwords: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        :param pulumi.Input[builtins.str] authentication_type: (Updatable) This is Authentication Type of Oracle Cloud Infrastructure cache user
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] hashed_passwords: (Updatable) SHA-256 hashed passwords for Oracle Cloud Infrastructure Cache user,required if authenticationType is set to PASSWORD.
        """
        pulumi.set(__self__, "authentication_type", authentication_type)
        if hashed_passwords is not None:
            pulumi.set(__self__, "hashed_passwords", hashed_passwords)

    @property
    @pulumi.getter(name="authenticationType")
    def authentication_type(self) -> pulumi.Input[builtins.str]:
        """
        (Updatable) This is Authentication Type of Oracle Cloud Infrastructure cache user
        """
        return pulumi.get(self, "authentication_type")

    @authentication_type.setter
    def authentication_type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "authentication_type", value)

    @property
    @pulumi.getter(name="hashedPasswords")
    def hashed_passwords(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        (Updatable) SHA-256 hashed passwords for Oracle Cloud Infrastructure Cache user,required if authenticationType is set to PASSWORD.
        """
        return pulumi.get(self, "hashed_passwords")

    @hashed_passwords.setter
    def hashed_passwords(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "hashed_passwords", value)


if not MYPY:
    class OciCacheUserGetRedisClusterOciCacheClusterArgsDict(TypedDict):
        oci_cache_cluster_id: NotRequired[pulumi.Input[builtins.str]]
        """
        OCID of the OciCacheCluster
        """
elif False:
    OciCacheUserGetRedisClusterOciCacheClusterArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class OciCacheUserGetRedisClusterOciCacheClusterArgs:
    def __init__(__self__, *,
                 oci_cache_cluster_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] oci_cache_cluster_id: OCID of the OciCacheCluster
        """
        if oci_cache_cluster_id is not None:
            pulumi.set(__self__, "oci_cache_cluster_id", oci_cache_cluster_id)

    @property
    @pulumi.getter(name="ociCacheClusterId")
    def oci_cache_cluster_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        OCID of the OciCacheCluster
        """
        return pulumi.get(self, "oci_cache_cluster_id")

    @oci_cache_cluster_id.setter
    def oci_cache_cluster_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "oci_cache_cluster_id", value)


if not MYPY:
    class RedisClusterGetOciCacheUserOciCacheUserArgsDict(TypedDict):
        oci_cache_user_id: NotRequired[pulumi.Input[builtins.str]]
        """
        OCID of the OciCacheUser
        """
elif False:
    RedisClusterGetOciCacheUserOciCacheUserArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class RedisClusterGetOciCacheUserOciCacheUserArgs:
    def __init__(__self__, *,
                 oci_cache_user_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] oci_cache_user_id: OCID of the OciCacheUser
        """
        if oci_cache_user_id is not None:
            pulumi.set(__self__, "oci_cache_user_id", oci_cache_user_id)

    @property
    @pulumi.getter(name="ociCacheUserId")
    def oci_cache_user_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        OCID of the OciCacheUser
        """
        return pulumi.get(self, "oci_cache_user_id")

    @oci_cache_user_id.setter
    def oci_cache_user_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "oci_cache_user_id", value)


if not MYPY:
    class RedisClusterNodeCollectionArgsDict(TypedDict):
        items: NotRequired[pulumi.Input[Sequence[pulumi.Input['RedisClusterNodeCollectionItemArgsDict']]]]
        """
        Collection of node objects.
        """
elif False:
    RedisClusterNodeCollectionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class RedisClusterNodeCollectionArgs:
    def __init__(__self__, *,
                 items: Optional[pulumi.Input[Sequence[pulumi.Input['RedisClusterNodeCollectionItemArgs']]]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input['RedisClusterNodeCollectionItemArgs']]] items: Collection of node objects.
        """
        if items is not None:
            pulumi.set(__self__, "items", items)

    @property
    @pulumi.getter
    def items(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RedisClusterNodeCollectionItemArgs']]]]:
        """
        Collection of node objects.
        """
        return pulumi.get(self, "items")

    @items.setter
    def items(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RedisClusterNodeCollectionItemArgs']]]]):
        pulumi.set(self, "items", value)


if not MYPY:
    class RedisClusterNodeCollectionItemArgsDict(TypedDict):
        display_name: NotRequired[pulumi.Input[builtins.str]]
        """
        (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        """
        private_endpoint_fqdn: NotRequired[pulumi.Input[builtins.str]]
        """
        The fully qualified domain name (FQDN) of the API endpoint to access a specific node.
        """
        private_endpoint_ip_address: NotRequired[pulumi.Input[builtins.str]]
        """
        The private IP address of the API endpoint to access a specific node.
        """
elif False:
    RedisClusterNodeCollectionItemArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class RedisClusterNodeCollectionItemArgs:
    def __init__(__self__, *,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 private_endpoint_fqdn: Optional[pulumi.Input[builtins.str]] = None,
                 private_endpoint_ip_address: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.str] display_name: (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        :param pulumi.Input[builtins.str] private_endpoint_fqdn: The fully qualified domain name (FQDN) of the API endpoint to access a specific node.
        :param pulumi.Input[builtins.str] private_endpoint_ip_address: The private IP address of the API endpoint to access a specific node.
        """
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if private_endpoint_fqdn is not None:
            pulumi.set(__self__, "private_endpoint_fqdn", private_endpoint_fqdn)
        if private_endpoint_ip_address is not None:
            pulumi.set(__self__, "private_endpoint_ip_address", private_endpoint_ip_address)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        (Updatable) A user-friendly name. Does not have to be unique, and it's changeable. Avoid entering confidential information.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="privateEndpointFqdn")
    def private_endpoint_fqdn(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The fully qualified domain name (FQDN) of the API endpoint to access a specific node.
        """
        return pulumi.get(self, "private_endpoint_fqdn")

    @private_endpoint_fqdn.setter
    def private_endpoint_fqdn(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "private_endpoint_fqdn", value)

    @property
    @pulumi.getter(name="privateEndpointIpAddress")
    def private_endpoint_ip_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The private IP address of the API endpoint to access a specific node.
        """
        return pulumi.get(self, "private_endpoint_ip_address")

    @private_endpoint_ip_address.setter
    def private_endpoint_ip_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "private_endpoint_ip_address", value)


if not MYPY:
    class GetOciCacheUsersFilterArgsDict(TypedDict):
        name: builtins.str
        """
        A filter to return the resources that match with the given Oracle Cloud Infrastructure cache user name.
        """
        values: Sequence[builtins.str]
        regex: NotRequired[builtins.bool]
elif False:
    GetOciCacheUsersFilterArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GetOciCacheUsersFilterArgs:
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        """
        :param builtins.str name: A filter to return the resources that match with the given Oracle Cloud Infrastructure cache user name.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        A filter to return the resources that match with the given Oracle Cloud Infrastructure cache user name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: builtins.str):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Sequence[builtins.str]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[builtins.bool]):
        pulumi.set(self, "regex", value)


if not MYPY:
    class GetRedisClusterNodesFilterArgsDict(TypedDict):
        name: builtins.str
        values: Sequence[builtins.str]
        regex: NotRequired[builtins.bool]
elif False:
    GetRedisClusterNodesFilterArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GetRedisClusterNodesFilterArgs:
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: builtins.str):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Sequence[builtins.str]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[builtins.bool]):
        pulumi.set(self, "regex", value)


if not MYPY:
    class GetRedisClustersFilterArgsDict(TypedDict):
        name: builtins.str
        values: Sequence[builtins.str]
        regex: NotRequired[builtins.bool]
elif False:
    GetRedisClustersFilterArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GetRedisClustersFilterArgs:
    def __init__(__self__, *,
                 name: builtins.str,
                 values: Sequence[builtins.str],
                 regex: Optional[builtins.bool] = None):
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)
        if regex is not None:
            pulumi.set(__self__, "regex", regex)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: builtins.str):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def values(self) -> Sequence[builtins.str]:
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Sequence[builtins.str]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def regex(self) -> Optional[builtins.bool]:
        return pulumi.get(self, "regex")

    @regex.setter
    def regex(self, value: Optional[builtins.bool]):
        pulumi.set(self, "regex", value)


